interface JavaScript {}

// box2d scene
JavaScript scene = null;

// setting the box2d scene
void setScene(JavaScript js) { 
	scene = js;
}

// setupd processing canvas
void setup() {
	size(800, 600);
	strokeWeight(5);
}

// draw loop
void draw() {
	// box2d code through javascript
	scene.world.Step(1/60, 10, 10);
	scene.world.ClearForces();
	
	var ballPos = scene.ball.GetBody().GetPosition();
	var ballRadius = scene.ball.GetShape().GetRadius();
	var ball = {
		x: ballPos.x * scene.SCALE,
		y: ballPos.y * scene.SCALE,
		radius: ballRadius * scene.SCALE
	}

	var floorPos = scene.floor.GetBody().GetPosition();
	var floorVertice = scene.floor.GetShape().GetVertices()[0];
	var floor = {
		x: floorPos.x * scene.SCALE,
		y: floorPos.y * scene.SCALE -15,
		width: Math.abs(floorVertice.x) * 2 * scene.SCALE,
		height: Math.abs(floorVertice.y) * 2 * scene.SCALE
	}

	// paint the scene
	background(100);
	fill(0, 121, 184);
	stroke(255);
	// draw the ball
	ellipse(ball.x, ball.y, ball.radius, ball.radius);
	// draw the ground
	rectMode(CENTER);
	stroke(0, 121, 184);
	rect(floor.x, floor.y, floor.width, floor.height);
}